import 'package:events2/events2.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

import 'features/me/bloc/me_bloc.dart';
import 'features/media_devices/bloc/media_devices_bloc.dart';
import 'features/peers/bloc/peers_bloc.dart';
import 'features/producers/bloc/producers_bloc.dart';
import 'features/room/bloc/room_bloc.dart';

List<BlocProvider> getRoomModules(
    String displayName, EventEmitter eventEmitter, localParticipantId) {
  return [
    BlocProvider<ProducersBloc>(
      lazy: false,
      create: (context) => ProducersBloc(
        eventEmitter: eventEmitter,
        localParticipantId: localParticipantId,
      ),
    ),
    BlocProvider<PeersBloc>(
      lazy: false,
      create: (context) => PeersBloc(
        mediaDevicesBloc: context.read<MediaDevicesBloc>(),
        eventEmitter: eventEmitter,
      ),
    ),
    BlocProvider<MeBloc>(
      lazy: false,
      create: (context) => MeBloc(
        displayName: displayName,
        id: localParticipantId,
      ),
    ),
    BlocProvider<RoomBloc>(
      lazy: false,
      create: (context) => RoomBloc(
        eventEmitter: eventEmitter,
      ),
    ),
  ];
}
